
%==============================================
%This code is written based on the Deep Learning Matlab toolbox
% First, you should put your hyperspectral data into the fold "Dataset", the file should be ".mat" format,and the data and its groundtruth are all needed.
% The hyperspectral image can be down from the websit "http://www.ehu.eus/ccwintco/index.php?title=Hyperspectral_Remote_Sensing_Scenes".
%==============================================
clc;
clear all;
addpath(genpath(pwd));

% load the ground truth and the hyperspectral image
%data
path='.\Dataset\';
inputsimage = 'PaviaU.mat';
Datapath = [path,inputsimage];
load (Datapath);

%groundtruth
inputGroundtruth = 'PaviaU_gt.mat';
GTpath = [path,inputGroundtruth];
load (GTpath);

%Generate the training and testing data
Percent_train = 0.1;
Percent_test = 1;
[paviaU_Train,paviaU_Test] = Select_train_and_test_sample_patial_Spectral(paviaU,paviaU_gt,Percent_train,Percent_test);

traindata = paviaU_Train.trainData;
trainlabel = paviaU_Train.trainLabel;

testdata = paviaU_Test.TestData;
testlabel = paviaU_Test.TestLabel;

rng(0)
cnn.layers = {
    struct('type', 'i') %input layer
    struct('type', 'c', 'outputmaps', 12, 'kernelsize', 10) %convolutional  layer 
    struct('type', 's', 'scale', 1) %sub sampling layer
    struct('type', 'c', 'outputmaps', 36, 'kernelsize', 10) %convolutional layer
    struct('type', 's', 'scale', 1) %subsampling layer
};

%full connection
cnn.numfullLine = 100;

%Iterative number
cnn.numepochs = 200; 

outlabel = RCNNsForClassification(traindata,trainlabel,testdata,testlabel,cnn);

%===========quality metrics and visual======================
Originalgroundtruth = 'PaviaU_gt.mat';
Groundtruthpath = [path,Originalgroundtruth];
load (Groundtruthpath);

[OA,AA,Kappa] = Compute_evaluate(trainlabel,testlabel,outlabel,paviaU_gt,paviaU_Test);
OA
AA
Kappa








